      .386
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************

;     include files
;     ~~~~~~~~~~~~~
      include \Masm32\include\windows.inc
      include \Masm32\include\user32.inc
      include \Masm32\include\kernel32.inc
      include \Masm32\include\gdi32.inc
      include \Masm32\include\comdlg32.inc
      include \Masm32\include\comctl32.inc
      include \Masm32\include\shell32.inc
      include \Masm32\include\ole32.inc 
      include \Masm32\com\include\oaidl.inc 
      include \Masm32\include\oleaut32.inc



;     libraries
;     ~~~~~~~~~

      includelib \Masm32\lib\user32.lib
      includelib \Masm32\lib\kernel32.lib
      includelib \Masm32\lib\gdi32.lib
      includelib \Masm32\lib\comdlg32.lib
      includelib \Masm32\lib\comctl32.lib
      includelib \Masm32\lib\shell32.lib
      includelib \Masm32\lib\ole32.lib  
      includelib \Masm32\lib\oleaut32.lib    

;**********************************************************************

        ;=================
        ; Local prototypes
        ;=================

        SetImageList            PROTO
        FindFullPath            PROTO :DWORD
        ShowFiles               PROTO
        DirThread               PROTO 
        AddImages               PROTO :DWORD
        CreateFileListBox       PROTO :DWORD
        GetLen                  PROTO :DWORD
        CreateDirListBox        PROTO :DWORD
        CreateDriveBox          PROTO :DWORD
        BuildThePath            PROTO :DWORD
        FindAllDirs             PROTO :DWORD,:DWORD
        FindAllDirs1            PROTO :DWORD
        CatCpy                  PROTO :DWORD,:DWORD
        dw2a                    PROTO :DWORD,:DWORD
        GetItemTextProc         PROTO :DWORD,:DWORD,:DWORD
        SetItemTextProc         PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WinMain                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        CreateButton            PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD 

        wsprintfA               PROTO C :DWORD,:VARARG
        wsprintf equ <wsprintfA>

      ;=============
      ; Local macros
      ;=============

RGB macro red,green,blue
        xor eax,eax
        mov ah,blue
        shl eax,8
        mov ah,green
        mov al,red
endm


      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM

     DATATEXT MACRO Text:VARARG
       LOCAL dbText

     .DATA
     dbText BYTE Text,0
     .CODE
    ExitM < offset dbText >
    ENDM

     FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

      LOWORD MACRO bigword  
        mov  eax,bigword
        and  eax,0FFFFh     ;; Set to low word 
      ENDM

      HIWORD MACRO bigword  
        mov  eax,bigword
        and  eax,0FFFF0000h     ;; Set to low word 
        ror eax,16
      ENDM

      COPYCAT MACRO Dest,Source1,Source2
            lea edi,Dest
            lea esi,Source1
  @@:       mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            cmp byte ptr [esi],0
            jnz @B
            lea esi,Source2
  @@:       mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            cmp byte ptr [esi],0
            jnz @B
            mov byte ptr [edi],0
      ENDM

      STRINGLEN MACRO Source
            lea esi,Source
            mov edi,esi
  @@:       inc esi
            cmp byte ptr [esi],0
            jnz @B
            sub esi,edi
            mov eax,esi
      ENDM

      STRINGCOPY MACRO Dest,Source
            lea edi,Dest
            lea esi,Source
  @@:       mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            cmp byte ptr [esi],0
            jnz @B
            mov byte ptr [edi],0      
      ENDM

      STRINGCAT MACRO Dest,Source
            lea edi,Dest
  @@:       inc edi
            cmp byte ptr [edi],0
            jnz @B
            lea esi,Source
  @@:       mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            cmp byte ptr [esi],0
            jnz @B
            mov byte ptr [edi],0      
      ENDM
.const
;Place all your Constance here.

.data
szShell32dll      db "shell32.dll",0
hLib              dd 0
hExitcode         dd 0
hThread           dd 0
pShell_GetImageLists dd 0
hStatusBar        dd 0
IconSize          dd 1
Found             dd 0
hitem             dd 0
Once              dd 1
Icon              dw 1
hWnd              dd 0
hInstance         dd 0
hImageListL       dd 0
hImageListS       dd 0
hDirListBox       dd 0
hDriveBox         dd 0
hListView         dd 0
hIcon             dd 0
Wwidth            dd 550
Wheight           dd 400
CommandLine       dd 0
hLastParent       dd 0
hNextParent       dd 0
ThreadID          dd 0
Thread_Done       dd 0
hIcon1            dd 0
hFont             dd 0
iSeparatorPos     dd 0
                  dd 0
pszSelPath        db MAX_PATH Dup(0)
pszSelName        db MAX_PATH Dup(0)
szObjects         db "Object(s) Found: "
ObjCount          db 20 Dup(0)
Temp              db MAX_PATH Dup(0)
szFindDir         db MAX_PATH Dup(0)
szAllFiles        db "*.*",0
                  db MAX_PATH Dup(0)
Pad               db 'C:\'
CurrentDir        db "C:\"
                  db MAX_PATH Dup(0)
szRootPath        db "C:\",0
                  db MAX_PATH Dup(0)
StartPath         db "C:\*",0
.data?
col         LVCOLUMN      <?>
TREEVIEWSTRUCT STRUCT
Xpos              dd ?
Ypos              dd ?
Xsize             dd ?
Ysize             dd ?
hModule           dd ?
hWin              dd ?
TextColor         dd ?
TextBKColor       dd ?
BKColor           dd ?
TREEVIEWSTRUCT ENDS
;wfd WIN32_FIND_DATA<?>
;wfd1 WIN32_FIND_DATA<?>
;wfd2 WIN32_FIND_DATA<?>
tvi               TV_INSERTSTRUCT<>
STATUSBAR  STRUCT
Part0         dd ?
Part1         dd ?
STATUSBAR ends
        
StatusBar STATUSBAR<>        
mousept   POINT<>
;**********************************************************************
.code

start:
      invoke GetModuleHandle, NULL
      mov hInstance,eax
      invoke CoInitialize,0
      invoke InitCommonControls
      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax

;**********************************************************************


WinMain proc hInst:DWORD, hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD


      ;====================
      ; Put LOCALs on stack
      ;====================

      LOCAL wc   :WNDCLASSEX
      LOCAL msg  :MSG

      ;==================================================
      ; Fill WNDCLASSEX structure with required variables
      ;==================================================

      invoke LoadIcon,hInst,500    ; icon ID
      mov hIcon, eax

      mov wc.cbSize, sizeof WNDCLASSEX
      mov wc.style,CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,offset WndProc
      mov wc.cbClsExtra,NULL
      mov wc.cbWndExtra,NULL
      m2m wc.hInstance,hInst
      mov wc.hbrBackground,COLOR_BTNFACE+1
      mov wc.lpszMenuName,NULL
      mov wc.lpszClassName,DATATEXT("#32770")
      m2m wc.hIcon,hIcon
      invoke LoadCursor,NULL,IDC_ARROW
      mov wc.hCursor,eax
      m2m wc.hIconSm,hIcon

      invoke RegisterClassEx, addr wc


      invoke CreateWindowEx,WS_EX_WINDOWEDGE,
                              DATATEXT("#32770"),
                              DATATEXT("Template"),
                              WS_TILEDWINDOW or WS_CLIPSIBLINGS or WS_VISIBLE or WS_CLIPCHILDREN,
                              10,10,Wwidth,Wheight,
                              NULL,NULL,
                              hInst,NULL
      mov hWnd,eax
      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

    StartLoop:
      invoke GetMessage,addr msg,NULL,0,0
      cmp eax,0
      je ExitLoop
      invoke TranslateMessage, addr msg
      invoke DispatchMessage,  addr msg
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain endp

;**********************************************************************
WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

              LOCAL rect         :RECT
              LOCAL wfd          :WIN32_FIND_DATA
              LOCAL rect1        :RECT
              LOCAL tvitem       :TV_ITEM
              LOCAL tvhit        :TV_HITTESTINFO
              LOCAL lvi          :LV_ITEM
              LOCAL buffer       [MAX_PATH] :BYTE
              LOCAL hSearch      :DWORD
              LOCAL hSelected    :DWORD
              LOCAL HitItem      :DWORD
              LOCAL Xpos         :DWORD
              LOCAL Ypos         :DWORD
              LOCAL Xsize        :DWORD
              LOCAL Ysize        :DWORD
              LOCAL Ssize        :DWORD
              LOCAL Old_Selection :DWORD
              LOCAL Vscroll      :DWORD
              LOCAL Hscroll      :DWORD

         .if uMsg == WM_CREATE
             invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or \
                              SBS_SIZEGRIP,NULL, hWin, 200
             mov hStatusBar, eax
             mov [StatusBar.Part0],125    
             mov [StatusBar.Part1],-1
             invoke SendMessage,hStatusBar,SB_SETPARTS,2,addr StatusBar
             invoke CreateFont,16,0,0,0,
                               FW_NORMAL,
                               FALSE,FALSE,FALSE,
                               ANSI_CHARSET,OUT_STROKE_PRECIS,
                               CLIP_STROKE_PRECIS,DRAFT_QUALITY,
                               FF_SWISS,DATATEXT("ARIAL BOLD")
             mov hFont,eax

             invoke CreateDriveBox,hWin
             invoke CreateDirListBox,hWin
             invoke CreateFileListBox,hWin
             mov  eax,OFFSET DirThread 
             invoke CreateThread,NULL,NULL,eax,0,0,ADDR ThreadID 
             invoke CloseHandle,eax
             invoke CreateButton,hWin,90,2,100,25,DATATEXT("Small View"),1001,0
             invoke CreateButton,hWin,195,2,100,25,DATATEXT("Large View"),1000,0
             invoke CreateButton,hWin,295,2,100,25,DATATEXT("Left Align"),1002,0
             invoke CreateButton,hWin,400,2,100,25,DATATEXT("Default Align"),1003,0

         .elseif uMsg == WM_COMMAND
          HIWORD wParam
          .if eax == CBN_SELCHANGE
              .if Thread_Done != 0
                  invoke MessageBox,hWin,DATATEXT("The DirListBox is Still Busy!"),DATATEXT("Alert!"),MB_OK or MB_ICONERROR
                  ret
              .endif
          invoke SendMessage,hDriveBox,CB_GETCURSEL,0,0
          invoke SendMessage,hDriveBox,CB_GETLBTEXT ,eax,addr szAllFiles
          mov esi,offset szAllFiles
          mov al,byte ptr[szAllFiles+2]
          mov byte ptr[StartPath],al
          mov byte ptr[szRootPath],al
          mov byte ptr[Pad],al
          mov byte ptr[CurrentDir],al
          mov byte ptr[CurrentDir+3],0

          mov  eax,OFFSET DirThread 
          invoke CreateThread,NULL,NULL,eax,0,0,ADDR ThreadID 
          invoke CloseHandle,eax
          invoke SetWindowText,hWin,addr CurrentDir
    	      invoke SendMessage,hListView,LVM_DELETEALLITEMS,0,0
          invoke ShowFiles

          .endif

         .if wParam == 1000
		    mov ebx,LVS_ICON
             invoke GetWindowLong,[hListView],GWL_STYLE
             and eax,0FFFFFFFCh
             or eax,ebx
             invoke SetWindowLong,[hListView],GWL_STYLE,eax
             invoke SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_NORMAL,hImageListL
             mov [IconSize],1
             invoke InvalidateRect,[hListView],NULL,NULL
             invoke UpdateWindow,[hListView]

         .endif

         .if wParam == 1001
		    mov ebx,LVS_SMALLICON
             invoke GetWindowLong,[hListView],GWL_STYLE
             and eax,0FFFFFFFCh
             or eax,ebx
             invoke SetWindowLong,[hListView],GWL_STYLE,eax
             invoke SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_SMALL,hImageListS
             mov [IconSize],0
             invoke InvalidateRect,[hListView],NULL,NULL
             invoke UpdateWindow,[hListView]
         .endif

         .if wParam == 1003
         invoke GetWindowLong,hListView,GWL_STYLE
         mov ebx,LVS_ALIGNLEFT
         xor ebx,0FFFFFFFFh
         and eax,ebx
         invoke SetWindowLong,hListView,GWL_STYLE,eax
         invoke SendMessage,hListView,LVM_ARRANGE,LVA_ALIGNLEFT, 0
         invoke InvalidateRect,hListView,0,TRUE
         invoke UpdateWindow,hListView
         .endif

         .if wParam == 1002
         invoke GetWindowLong,hListView,GWL_STYLE
         or eax,LVS_ALIGNLEFT
         invoke SetWindowLong,hListView,GWL_STYLE,eax
         invoke SendMessage,hListView,LVM_ARRANGE,LVA_ALIGNLEFT, 0
         invoke InvalidateRect,hListView,0,TRUE
         invoke UpdateWindow,hListView
         .endif

         .elseif uMsg == WM_SIZE
                 invoke MoveWindow,hStatusBar,0,0,0,0,TRUE
                 invoke GetWindowRect,hDirListBox,addr rect1
                 mov eax,rect1.right
                 sub eax,[rect1.left]
                 mov [rect1.right],eax
                 invoke GetClientRect,hStatusBar,addr rect
                 mov eax,[rect.bottom]
                 mov [Ssize],eax
                 invoke GetClientRect,hWin,addr rect
                 mov eax,[rect.bottom]
                 sub eax,[Ssize]
                 sub eax,30
                 mov [Ysize],eax
                 invoke SetWindowPos,hDirListBox,0,0,30,rect1.right,Ysize,SWP_NOMOVE
                 mov eax,[rect.right]
                 sub eax,[rect1.right]
                 sub eax,4
                 add rect1.right,4
                 invoke SetWindowPos,hListView,0,rect1.right,30,eax,Ysize,0
;*****************************************************************************
;
;
;*****************************************************************************
         .elseif uMsg == WM_NOTIFY
                 mov esi,lParam
                 assume esi:ptr NMHDR
                 .if [esi].NMHDR.code == NM_DBLCLK
                     mov eax,[esi].NMHDR.hwndFrom
                     .if eax == hListView
                         invoke SendMessage,hListView,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
                         or eax,eax
                         js No_Good
                         mov [lvi.iItem],eax
                         mov [lvi.iSubItem],0
                         mov [lvi.imask],LVIF_PARAM or LVIF_TEXT
                         mov [lvi.pszText],offset pszSelName
                         mov [lvi.cchTextMax],MAX_PATH
                         mov byte ptr[pszSelPath],0
                         invoke SendMessage,[hListView],LVM_GETITEM,0,addr lvi
                         invoke BuildThePath,addr pszSelPath-1
                         invoke lstrcat,addr pszSelPath,DATATEXT("\")
                         invoke lstrcat,addr pszSelPath,addr pszSelName
                         invoke ShellExecute,NULL,DATATEXT("Open"),addr pszSelPath,NULL,NULL,SW_SHOW
                     .endif
                  .endif
                 assume esi:nothing
No_Good:
                 mov esi,lParam
                 assume esi:ptr NMHDR
                 .if [esi].NMHDR.code == NM_CLICK
                     invoke GetCursorPos,addr tvhit.pt 
                     invoke ScreenToClient,hDirListBox,addr tvhit.pt 
                     invoke SendMessage,hDirListBox,TVM_HITTEST,0,addr tvhit 
                     mov eax,[tvhit.flags] 
                 .if eax == TVHT_ONITEMBUTTON
                     mov HitItem,0
                     mov eax,[tvhit.hItem]
				    mov [tvitem.hItem],eax
				    mov [tvitem.imask],TVIF_PARAM
				    invoke SendMessage,[hDirListBox],TVM_GETITEM,0,addr tvitem
				    mov eax,[tvitem.lParam]
				    .if eax == TRUE
                         jmp HTest_Done

                     .elseif eax == FALSE
					    invoke PostMessage,[hDirListBox],TVM_SELECTITEM,TVGN_CARET,[tvhit.hItem]
                          invoke PostMessage,hDirListBox,TVM_EXPAND,TVE_EXPAND,tvhit.hItem
                          jmp Hit_Item                       
                     .endif

                 .endif
                 .endif

                  mov esi,lParam
                  assume esi:ptr NM_TREEVIEW

 		     .if [esi].hdr.code == TVN_SELCHANGED
Hit_Item:
                  invoke SendMessage,hDirListBox,TVM_GETNEXTITEM,TVGN_CARET,0
                  push eax
                  mov [hSelected],eax
                  assume esi:nothing
                  mov ecx,1
Get_All_Parents:
                  push ecx
                  invoke SendMessage,hDirListBox,TVM_GETNEXTITEM,TVGN_PARENT,eax
                  pop ecx
                      .if eax != 0
                          push eax
                          inc ecx
                          jmp Get_All_Parents
                      .endif
;********************************************************
                     lea edi,szFindDir
                     mov dword ptr[edi],0
                     mov [tvitem.pszText],edi
                     lea edi,CurrentDir
                     mov dword ptr[edi],0
                     mov [tvitem.cchTextMax],MAX_PATH
                     mov [tvitem.imask],TVIF_TEXT or TVIF_PARAM or TVIF_CHILDREN

                     
                     .if ecx != 0
Build_All:           
                         pop eax
                         dec ecx
                         mov [tvitem.hItem],eax
                         push ecx
                         invoke SendMessage,hDirListBox,TVM_GETITEM,0,addr tvitem
                         invoke lstrlen,addr CurrentDir
                         mov edi,offset CurrentDir
                         add edi,eax
                         dec edi
                     .if byte ptr[edi] != '\'
                         inc edi
                         mov word ptr[edi],'\'
                     .endif
                     invoke lstrcat,addr CurrentDir,tvitem.pszText
                     pop ecx
                     .if ecx != 0
                         jmp Build_All
                     .endif  
                     .endif

                     invoke SetWindowText,hWin,addr CurrentDir
                     invoke lstrlen,addr CurrentDir
                     mov edi,offset CurrentDir
                     add edi,eax
                     dec edi
                     .if byte ptr[edi] != '\'
                      inc edi
                      mov dword ptr[edi],'*\'
                     .else
                      inc edi
                      mov word ptr[edi],'*' 
                     .endif

                     invoke GetExitCodeThread,[hThread],offset hExitcode
                     mov eax,[hExitcode]
                     .if eax == STILL_ACTIVE
                     invoke TerminateThread,hThread,0
                     invoke CloseHandle,hThread
                     .endif
                     invoke SendMessage,hListView,LVM_DELETEALLITEMS,0,0
                     mov eax,OFFSET ShowFiles 
                     invoke CreateThread,NULL,NULL,eax,0,0,ADDR ThreadID
                     mov hThread,eax 

                     mov eax,[tvitem.hItem]
                     mov eax,[hSelected]
                     mov [tvitem.hItem],eax
                     mov [tvitem.cchTextMax],MAX_PATH
                     mov [tvitem.imask],TVIF_TEXT or TVIF_PARAM or TVIF_CHILDREN
                     invoke SendMessage,hDirListBox,TVM_GETITEM,0,addr tvitem
                     .if [tvitem.cChildren] == 0
                         ret
                     .endif
                 .if Thread_Done == 1
                     ret
                 .endif

;*********************************************************************
                     invoke SendMessage,hDirListBox,TVM_GETNEXTITEM,TVGN_CARET,0
                     mov [tvi.hParent],eax
                     mov [hSelected],eax
                     mov [tvitem.hItem],eax
                     mov [tvitem.cchTextMax],MAX_PATH
                     lea edi,szFindDir
                     mov byte ptr [edi],0
                     mov [tvitem.pszText],edi
                     mov [tvitem.imask],TVIF_TEXT or TVIF_PARAM or TVIF_CHILDREN
                     invoke SendMessage,hDirListBox,TVM_GETITEM,0,addr tvitem
                     .if tvitem.lParam == FALSE
                         mov [tvitem.lParam],TRUE
                         invoke SendMessage,hDirListBox,TVM_SETITEM,0,addr tvitem

;*******************************************************************
                     mov tvi.hInsertAfter,TVI_ROOT or TVI_SORT ;ROOT
                     mov tvi.item.imask,TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE or TVIF_PARAM or TVIF_CHILDREN
                     lea eax,wfd.cFileName
                     mov tvi.item.pszText,eax
                     mov tvi.item.iImage,0
                     mov tvi.item.iSelectedImage,1
                     invoke FindAllDirs,addr CurrentDir,tvi.hParent
                     invoke SendMessage,hDirListBox,TVM_EXPAND,TVE_EXPAND,tvhit.hItem
                     ret
                 .endif
                 .endif

;*****************************************************************************
;
;
;*****************************************************************************
HTest_Done:
         .elseif uMsg == WM_MEASUREITEM
                 .if wParam == 300
                     mov edi,lParam
                     assume edi:ptr MEASUREITEMSTRUCT
                     m2m [edi].itemWidth,80
                     m2m [edi].itemHeight,25
                 .endif
                     return 1;
                     assume edi:nothing
;*****************************************************************************
;
;
;*****************************************************************************
          .elseif uMsg == WM_DRAWITEM
                  .if wParam == 300
                       mov edi, lParam
                       assume edi:ptr DRAWITEMSTRUCT
                       invoke SetBkMode,[edi].hdc,TRANSPARENT
                       invoke SelectObject,[edi].hdc,hFont
;*******************************************************
; DRAW BACKGROUND
;*******************************************************
                   .if [edi].itemAction == ODA_SELECT && [edi].itemState == 0
                           invoke GetSysColor,COLOR_WINDOWTEXT
                           invoke SetTextColor,[edi].hdc,eax
                           invoke GetSysColor,COLOR_WINDOW
                           invoke CreateSolidBrush,eax
                           invoke FillRect,[edi].hdc,addr [edi].rcItem,eax
                           invoke DeleteObject,eax
                   .else
                           invoke GetSysColor,COLOR_HIGHLIGHTTEXT
                           invoke SetTextColor,[edi].hdc,eax
                           invoke GetSysColor,COLOR_HIGHLIGHT
                           invoke CreateSolidBrush,eax
                           invoke FillRect,[edi].hdc,addr [edi].rcItem,eax
                           invoke DeleteObject,eax

                   .endif

                   .if [edi].itemAction == ODA_DRAWENTIRE && [edi].itemState == 0
                           invoke GetSysColor,COLOR_WINDOWTEXT
                           invoke SetTextColor,[edi].hdc,eax
                           invoke GetSysColor,COLOR_WINDOW
                           invoke CreateSolidBrush,eax
                           invoke FillRect,[edi].hdc,addr [edi].rcItem,eax
                           invoke DeleteObject,eax
                   .endif

                   invoke LoadImage,hInstance,501,IMAGE_ICON,16,16,LR_DEFAULTCOLOR
                   mov hIcon1, eax

                  .if (hIcon1 != 0)
                       mov eax,[edi].rcItem.top
                       invoke DrawIconEx,[edi].hdc,3,eax,hIcon1,16,16,0,0,DI_NORMAL
                  .endif
                  push 26
                  pop [edi].rcItem.left
                  invoke lstrlen,[edi].itemData
                  mov [edi].itemAction,eax

                  invoke DrawText,[edi].hdc,[edi].itemData,[edi].itemAction,addr [edi].rcItem,DT_SINGLELINE or DT_NOCLIP or DT_VCENTER 
                  invoke GetStockObject,BLACK_BRUSH
                  invoke SelectObject,[edi].hdc,eax
                  invoke GetStockObject,BLACK_PEN
                  invoke SelectObject,[edi].hdc,eax
                  invoke GetStockObject,DEFAULT_GUI_FONT
                  invoke SelectObject,[edi].hdc,eax
                  invoke DestroyIcon,hIcon1
            .endif			
                  return 1
                       assume edi:nothing

    .elseif uMsg == WM_MOUSEMOVE
            invoke GetClientRect,hWin,addr rect
            add rect.top,30
            invoke GetCursorPos,addr mousept
            invoke ScreenToClient,hWin,addr mousept
	        invoke PtInRect,addr rect, mousept.x, mousept.y
            .if (eax)            
                invoke LoadCursor,0,IDC_SIZEWE
                invoke SetCursor,eax	

	   .if wParam == MK_LBUTTON 
           invoke GetCursorPos,addr mousept
           invoke ScreenToClient,hWin,addr mousept
           mov eax,[mousept.x]
	       mov iSeparatorPos,eax
           invoke GetClientRect,hStatusBar,addr rect
           mov eax,[rect.bottom]
           mov [Ssize],eax
           invoke GetClientRect,hWin,addr rect
           add rect.top,30
           mov eax,[rect.bottom]
           sub eax,Ssize
           sub eax,30
           mov [rect.bottom],eax
           mov eax,iSeparatorPos 
           dec eax 
           invoke MoveWindow,hDirListBox,0,rect.top,eax,rect.bottom,TRUE 
           push rect.right
           push rect.bottom
           invoke GetWindowRect,hDirListBox,addr rect
           invoke ScreenToClient,hWin,addr rect
           invoke ScreenToClient,hWin,addr rect+8
           pop rect.bottom
           pop eax
           sub eax,rect.right
           dec eax
           dec eax
           dec eax
           mov rect.right,eax
           mov eax,iSeparatorPos 
           inc eax
           inc eax
           invoke MoveWindow,hListView,eax,rect.top,rect.right,rect.bottom,TRUE 
        .endif
        .endif

 
    .elseif uMsg == WM_LBUTTONDOWN
            invoke GetClientRect,hWin,addr rect
            add rect.top,30
            invoke GetCursorPos,addr mousept
            invoke ScreenToClient,hWin,addr mousept
            invoke PtInRect,addr rect, mousept.x, mousept.y
            .if (eax)            
                invoke SetCapture,hWin
                invoke LoadCursor,0,IDC_SIZEWE
                invoke SetCursor,eax
            .endif


    .elseif uMsg == WM_LBUTTONUP
            invoke ReleaseCapture
            invoke LoadCursor,0,IDC_ARROW
            invoke SetCursor,eax	

         .elseif uMsg == WM_DESTROY
                 invoke PostQuitMessage,NULL
                 xor eax,eax
                 ret
         .endif

            invoke DefWindowProc,hWin,uMsg,wParam,lParam
            ret
WndProc endp
;*************************************************************
;
;
;*************************************************************
CreateDirListBox Proc hWin:DWORD 


     invoke InitCommonControls
     mov eax,WS_CHILDWINDOW or WS_MAXIMIZEBOX or WS_CLIPSIBLINGS or WS_VISIBLE
     or eax,TVS_SHOWSELALWAYS or TVS_LINESATROOT or TVS_HASLINES or TVS_HASBUTTONS
     invoke CreateWindowEx,WS_EX_ACCEPTFILES or WS_EX_NOPARENTNOTIFY or WS_EX_CLIENTEDGE,
                           DATATEXT("SysTreeView32"),
                           NULL,
                           eax,
                           0,30,250,325,
                           hWin,
                           2300,
                           hInstance,
                           NULL               
        mov  hDirListBox,eax
        invoke SetImageList
        mov eax,[hDirListBox]
        invoke SendMessage,hDirListBox,TVM_DELETEITEM,0,0
        mov tvi.hInsertAfter,TVI_ROOT or TVI_SORT ;ROOT
        mov tvi.item.imask,TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE or TVIF_PARAM
        mov tvi.item.pszText,offset szRootPath
        mov tvi.item.iImage,2
        mov tvi.item.iSelectedImage,2
        mov tvi.item.lParam,TRUE
        invoke SendMessage,hDirListBox,TVM_INSERTITEM,0,addr tvi
        ret
CreateDirListBox endp
;**********************************************************************
;
;
;**********************************************************************
FindAllDirs proc PathStr:DWORD,Parent:DWORD

             LOCAL DispBuffer[MAX_PATH]  :BYTE
             LOCAL PathBuffer[MAX_PATH]  :BYTE
             LOCAL hSearch               :DWORD
             LOCAL wfd                   :WIN32_FIND_DATA

        mov tvi.hInsertAfter,TVI_ROOT or TVI_SORT ;ROOT
        mov tvi.item.imask,TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE or TVIF_PARAM or TVIF_CHILDREN
        lea eax,wfd.cFileName
        mov tvi.item.pszText,eax
        mov tvi.item.iImage,0
        mov tvi.item.iSelectedImage,1
     
        mov eax,Parent
        mov [tvi.hParent],eax
        invoke FindFirstFile,PathStr,addr wfd
        cmp eax,INVALID_HANDLE_VALUE
        jz Find_Leave
        mov hSearch,eax
Find_Next_Dir:
        mov al,byte ptr[wfd.cFileName]
        cmp al,02Eh
        jz Find_Next
        mov eax,dword ptr [wfd.dwFileAttributes]
        and eax,FILE_ATTRIBUTE_DIRECTORY
        cmp eax,FILE_ATTRIBUTE_DIRECTORY
        jnz Find_Next
;********************************************************************
; Do a fast copy and cat.
;********************************************************************
        lea edi,PathBuffer
        mov esi,PathStr
  @@:   mov al,[esi]
        mov [edi],al
        inc esi
        inc edi
        cmp byte ptr [esi],0
        jnz @B
        dec edi
        lea esi,wfd.cFileName
  l2:   mov al,[esi]
        mov [edi],al
        inc esi
        inc edi
        cmp byte ptr [esi],0
        jnz l2
;********************************************************************
; Fix new search path string.
;********************************************************************
        mov dword ptr[edi],'*\'
        invoke FindAllDirs1,addr PathBuffer ;Look Ahead into this folder.
        .if eax == 0 ; if Zero, there is no folders in this folder.
        mov eax,tvi.hParent
        mov tvi.hParent,eax
        mov tvi.item.lParam,FALSE
        mov tvi.item.cChildren,0
        invoke SendMessage,hDirListBox,TVM_INSERTITEM,0,addr tvi
        .else
        mov eax,tvi.hParent
        mov tvi.hParent,eax
        mov tvi.item.lParam,FALSE
        mov tvi.item.cChildren,1
        invoke SendMessage,hDirListBox,TVM_INSERTITEM,0,addr tvi
        .endif

Find_Next:
        invoke FindNextFile,hSearch,addr wfd
        cmp eax,0
        jnz Find_Next_Dir
        invoke GetLastError
No_Error:
        cmp eax,ERROR_NO_MORE_FILES
        jnz Find_Next_Dir
Find_Leave:
       invoke FindClose,hSearch
       mov eax,tvi.hParent
       ret
FindAllDirs endp
;**********************************************************************
;
;
;**********************************************************************
FindAllDirs1 proc PathStr:DWORD

             LOCAL DispBuffer[MAX_PATH]  :BYTE
             LOCAL PathBuffer[MAX_PATH]  :BYTE
             LOCAL hSearch               :DWORD
             LOCAL wfd                   :WIN32_FIND_DATA


        invoke FindFirstFile,PathStr,addr wfd
        cmp eax,INVALID_HANDLE_VALUE
        jz Find_Leave
        mov hSearch,eax
Find_Next_Dir:
        mov al,byte ptr[wfd.cFileName]
        cmp al,02Eh
        jz Find_Next
        mov eax,dword ptr [wfd.dwFileAttributes]
        and eax,FILE_ATTRIBUTE_DIRECTORY
        cmp eax,FILE_ATTRIBUTE_DIRECTORY
        jnz Find_Next
        mov eax,0FFFFFFFFh
        ret
Find_Next:
        invoke FindNextFile,hSearch,addr wfd
        cmp eax,0
        jnz Find_Next_Dir
        invoke GetLastError
No_Error:
        cmp eax,ERROR_NO_MORE_FILES
        jnz Find_Next_Dir
Find_Leave:
       invoke FindClose,hSearch
       xor eax,eax
       ret
FindAllDirs1 endp

;**********************************************************************
;
;
;**********************************************************************
SetImageList proc

            LOCAL hDImageList         :DWORD
            LOCAL hBitmap             :DWORD

		invoke ImageList_Create,16,16,ILC_COLOR16 or ILC_MASK,1,10
         mov hDImageList,eax

         invoke LoadIcon,hInstance,600
         mov hBitmap,eax
		invoke ImageList_AddIcon,hDImageList,hBitmap
		invoke DeleteObject,hBitmap

         invoke LoadIcon,hInstance,601
         mov hBitmap,eax
		invoke ImageList_AddIcon,hDImageList,hBitmap
		invoke DeleteObject,hBitmap

         invoke LoadIcon,hInstance,501
         mov hBitmap,eax
		invoke ImageList_AddIcon,hDImageList,hBitmap
		invoke DeleteObject,hBitmap

         invoke SendMessage,hDirListBox,TVM_SETIMAGELIST,0,hDImageList
         ret
SetImageList endp
;**********************************************************************
;
;
;**********************************************************************
DirThread proc

        LOCAL rect       :RECT
        LOCAL citem      :DWORD
        LOCAL wfd        :WIN32_FIND_DATA

        mov [Thread_Done],1
        invoke LoadCursor,0,IDC_WAIT
        invoke SetCursor,eax
        invoke SendMessage,hDirListBox,TVM_DELETEITEM,0,0
        mov eax,0 ;xor eax,eax
        mov tvi.hParent,eax
        mov tvi.hInsertAfter,TVI_ROOT ;ROOT
        mov tvi.item.imask,TVIF_PARAM or TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
        mov tvi.item.pszText,offset szRootPath
        mov tvi.item.iImage,2
        mov tvi.item.iSelectedImage,2
        mov tvi.item.lParam,TRUE
        invoke SendMessage,hDirListBox,TVM_INSERTITEM,0,addr tvi
        mov [citem],eax
        invoke SendMessage,hDirListBox,TVM_EXPAND,TVE_EXPAND,0
        mov eax,[citem]
        mov tvi.hParent,eax
        mov tvi.hInsertAfter,TVI_ROOT or TVI_SORT ;ROOT
        mov tvi.item.imask,TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE or TVIF_PARAM or TVIF_CHILDREN
        lea eax,wfd.cFileName
        mov tvi.item.pszText,eax
        mov tvi.item.iImage,0
        mov tvi.item.iSelectedImage,1
        invoke SendMessage,hDirListBox,TVM_SELECTITEM,TVGN_CARET,citem
        invoke InvalidateRect,hDirListBox,0,TRUE
        invoke UpdateWindow,hDirListBox
        invoke FindAllDirs,addr StartPath,tvi.hParent
        invoke SendMessage,hDirListBox,TVM_SELECTITEM,TVGN_CARET,citem
        invoke SendMessage,hDirListBox,TVM_EXPAND,TVE_EXPAND,citem
        invoke InvalidateRect,hDirListBox,0,TRUE
        invoke UpdateWindow,hDirListBox
        invoke LoadCursor,0,IDC_ARROW
        invoke SetCursor,eax
        mov [Thread_Done],0
        ret
DirThread endp
;*************************************************************
;
;
;*************************************************************
CreateDriveBox Proc hWin:DWORD 

     mov eax,WS_CHILDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
     or eax,CBS_OWNERDRAWFIXED or CBS_NOINTEGRALHEIGHT or CBS_DROPDOWNLIST or CBS_HASSTRINGS 
     invoke CreateWindowEx,WS_EX_LEFT,
                           DATATEXT("COMBOBOX"),
                           NULL,
                           eax,
                           0,0,80,450,
                           hWin,
                           300,
                           hInstance,
                           NULL               
        mov  hDriveBox,eax
        invoke SendMessage,hDriveBox,CB_DIR,DDL_DRIVES or DDL_EXCLUSIVE,addr szAllFiles
        invoke SendMessage,hDriveBox,CB_SETCURSEL,1,0
        invoke SendMessage,hDriveBox,CB_SETITEMHEIGHT,-1,15
        invoke SendMessage,hDriveBox,CB_SETITEMHEIGHT,1,15
        invoke SendMessage,hDriveBox,CB_GETCOUNT,0,0
        mov ecx,eax
        mov edi,offset szAllFiles
        mov byte ptr[edi],0
        mov ebx,0
Next_Drive:
        push ecx
        push edi
        push ebx
        invoke SendMessage,hDriveBox,CB_GETLBTEXT ,ebx,edi
        invoke lstrlen,addr szAllFiles
        pop ebx
        pop edi
        pop ecx
        add edi,eax
        inc edi
        inc ebx
        loop Next_Drive
        mov edi,offset szAllFiles
        mov ebx,0
Add_All:
        push edi
        push ebx
        mov al,[edi]
        .if al != 0
            invoke SendMessage,hDriveBox,CB_SETITEMDATA,ebx,edi
        .endif
        pop ebx
        pop edi
        invoke lstrlen,edi
        add edi,eax
        inc edi
        inc ebx
        mov al,[edi]
        .if al != 0
            jmp Add_All
        .endif
        ret
CreateDriveBox endp
;*************************************************************
;
;
;*************************************************************
CreateFileListBox Proc hWin:DWORD 

     invoke InitCommonControls
     mov eax,WS_VSCROLL or WS_CLIPSIBLINGS or WS_VISIBLE or WS_CHILDWINDOW
     or eax,LVS_SHAREIMAGELISTS or WS_MAXIMIZEBOX
     invoke CreateWindowEx,WS_EX_NOPARENTNOTIFY or WS_EX_ACCEPTFILES or WS_EX_CLIENTEDGE,
                           DATATEXT("SysListView32"),
                           NULL,
                           eax,
                           255,30,285,325,
                           hWin,
                           350,
                           hInstance,
                           NULL               
        mov  hListView,eax
        invoke SetFocus,hListView
        RGB  0,0,0
        invoke SendMessage,hListView,LVM_SETTEXTCOLOR,NULL,eax
        RGB  255,255,255
        invoke SendMessage,hListView,LVM_SETBKCOLOR,NULL,eax
        RGB  255,255,255
        invoke SendMessage,hListView,LVM_SETTEXTBKCOLOR,NULL,eax
        invoke SendMessage,hListView,LVM_DELETEALLITEMS,0,0
        invoke ShowFiles
        ret

CreateFileListBox endp
;******************************************************************
;
;
;******************************************************************
ShowFiles proc 

        LOCAL FilePath       [MAX_PATH] :BYTE
        LOCAL szSearch       [MAX_PATH] :BYTE
        LOCAL hSearch                   :DWORD
        LOCAL sfi                       :SHFILEINFO  
        LOCAL lvi                       :LV_ITEM 
        LOCAL rect                      :RECT 
        LOCAL wfd                       :WIN32_FIND_DATA

        mov hitem,0
        mov Icon,0
        invoke LoadCursor,0,IDC_WAIT
        invoke SetCursor,eax
        STRINGCOPY szSearch,CurrentDir
        .if hImageListS == 0
            invoke GetModuleHandle,addr szShell32dll 
            mov hLib,eax 
            invoke GetProcAddress,hLib,71 
            mov pShell_GetImageLists,eax
            mov edi,offset hImageListS
            push edi
            mov edi,offset hImageListL
            push edi
            call pShell_GetImageLists
            invoke SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_NORMAL,hImageListL
            invoke SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_SMALL,hImageListS
            invoke SendMessage,hListView,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES + LVS_EX_HEADERDRAGDROP,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT + LVS_EX_HEADERDRAGDROP 
        .endif
        invoke SendMessage,hListView,LVM_GETITEMCOUNT,0,0
        mov [hitem],eax
        mov lvi.imask,LVIF_TEXT or LVIF_IMAGE
        mov lvi.cchTextMax,MAX_PATH
        mov lvi.iSubItem,0

        STRINGCAT szSearch,DATATEXT("*.*")
        invoke FindFirstFile,addr szSearch,addr wfd
        mov [hSearch],eax
Show_All:
        mov eax,[wfd.dwFileAttributes]
        and eax,FILE_ATTRIBUTE_DIRECTORY
        cmp eax,FILE_ATTRIBUTE_DIRECTORY 
        jz Bad_File
;************************************************************************************
Good_File:
        invoke Sleep,1
        invoke lstrcpy,addr FilePath,addr CurrentDir 
        invoke lstrlen,addr FilePath 
        lea eax,[FilePath+eax-1] 
        mov BYTE PTR [eax],0 
        invoke lstrcat,addr FilePath,addr wfd.cFileName
        inc hitem
        invoke SHGetFileInfo,addr FilePath,0,addr sfi,sizeof SHFILEINFO,SHGFI_SYSICONINDEX
        lea eax,wfd.cFileName 
        mov lvi.pszText,eax
        mov eax,hitem
        mov lvi.iItem,eax
        mov eax,sfi.iIcon
        mov lvi.iImage,eax
        invoke SendMessage,hListView,LVM_INSERTITEM,0,addr lvi
Bad_File:
        invoke FindNextFile,hSearch,addr wfd
        cmp eax,TRUE
        jz Show_All
        invoke FindClose,hSearch
        invoke LoadCursor,0,IDC_ARROW
        invoke SetCursor,eax
        invoke dw2a,hitem,addr ObjCount
        invoke SendMessage,hStatusBar,SB_SETTEXT,0,addr szObjects
        ret
ShowFiles endp
.data
ButtonClass         db "BUTTON",0
hModule             dd 0

.code

;*******************************************************************
;
;
;*******************************************************************
CreateButton proc hWin:DWORD,Xpos:DWORD,Ypos:DWORD,Xsize:DWORD,
                  Ysize:DWORD,lpButtonText:DWORD,ID:DWORD,dwType:DWORD 

            invoke GetModuleHandle,NULL
            mov hModule, eax
            .if dwType == 0
                mov eax,WS_CHILD OR WS_VISIBLE
            .endif
            .if dwType == 1
                mov eax,BS_BITMAP or WS_CHILD OR WS_VISIBLE
            .endif
            invoke CreateWindowEx,WS_EX_LEFT,
                                  addr ButtonClass,lpButtonText,
                                  eax,
                                  Xpos,Ypos,Xsize,Ysize,hWin,ID,
                                  hModule,NULL
            ret
CreateButton endp
;********************************************************************
    .data
      fMtStrinG db "%lu",0

    .code

; #########################################################################

dw2a proc dwValue:DWORD, lpBuffer:DWORD

    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is passed as a value, direct, indirect or in register
    ; lpBuffer is the ADDRESS of the receiving buffer
    ; EXAMPLE:
    ; invoke dw2a,edx,ADDR buffer
    ; -------------------------------------------------------------
    
    invoke wsprintf,lpBuffer,ADDR fMtStrinG,dwValue

    ret

dw2a endp
;********************************************************************
;
;
;********************************************************************
BuildThePath Proc pBuffer:DWORD

             LOCAL tvitem        :TV_ITEM

                  invoke SendMessage,hDirListBox,TVM_GETNEXTITEM,TVGN_CARET,0
                  push eax
                  mov ecx,1
Get_All_Parents:
                  push ecx
                  invoke SendMessage,hDirListBox,TVM_GETNEXTITEM,TVGN_PARENT,eax
                  pop ecx
                      .if eax != 0
                          push eax
                          inc ecx
                          jmp Get_All_Parents
                      .endif
;********************************************************
                     lea edi,szFindDir
                     mov dword ptr[edi],0
                     mov [tvitem.pszText],edi
                     mov edi,pBuffer
                     mov dword ptr[edi],0
                     mov [tvitem.cchTextMax],MAX_PATH
                     mov [tvitem.imask],TVIF_TEXT or TVIF_PARAM or TVIF_CHILDREN

                     
                     .if ecx != 0
Build_All:           
                         pop eax
                         dec ecx
                         mov [tvitem.hItem],eax
                         push ecx
                         invoke SendMessage,hDirListBox,TVM_GETITEM,0,addr tvitem
                         invoke lstrlen,pBuffer
                         mov edi,pBuffer
                         add edi,eax
                         dec edi
                     .if byte ptr[edi] != '\'
                         inc edi
                         mov word ptr[edi],'\'
                     .endif
                     invoke lstrcat,pBuffer,tvitem.pszText
                     pop ecx
                     .if ecx != 0
                         jmp Build_All
                     .endif  
                     .endif
                    ret
BuildThePath endp

end start
